regina::NSpiralSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a spiralled solid torus in a triangulation. More...

`#include <subcomplex/nspiralsolidtorus.h>`

Inheritance diagram for regina::NSpiralSolidTorus:

## Public Member Functions

virtual | ~NSpiralSolidTorus ()
| Destroys this spiralled solid torus. More...
NSpiralSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
unsigned long | getNumberOfTetrahedra () const
| Returns the number of tetrahedra in this spiralled solid torus. More...
NTetrahedron * | getTetrahedron (unsigned long index) const
| Returns the requested tetrahedron in this spiralled solid torus. More...
NPerm4 | getVertexRoles (unsigned long index) const
| Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus. More...
void | reverse ()
| Reverses this spiralled solid torus. More...
void | cycle (unsigned long k)
| Cycles this spiralled solid torus by the given number of tetrahedra. More...
bool | makeCanonical (const NTriangulation *tri)
| Converts this spiralled solid torus into its canonical representation. More...
bool | isCanonical (const NTriangulation *tri) const
| Determines whether this spiralled solid torus is in canonical form. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NSpiralSolidTorus * | formsSpiralSolidTorus (NTetrahedron *tet, NPerm4 useVertexRoles)
| Determines if the given tetrahedron forms part of a spiralled solid torus with its vertices playing the given roles in the solid torus. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a spiralled solid torus in a triangulation.

A spiralled solid torus is created by placing tetrahedra one upon another in a spiralling fashion to form a giant loop.

For each tetrahedron, label the vertices A, B, C and D. Draw the tetrahedron so that the vertices form an upward spiral in the order A-B-C-D, with D directly above A. Face BCD is on the top, face ABC is on the bottom and faces ABD and ACD are both vertical.

When joining two tetrahedra, face BCD of the lower tetrahedron will be joined to face ABC of the upper tetrahedron. In this way the tetrahedra are placed one upon another to form a giant loop (which is closed up by placing the bottommost tetrahedron above the topmost tetrahedron in a similar fashion), forming a solid torus overall.

In each tetrahedron, directed edges AB, BC and CD are major edges, directed edges AC and BD are minor edges and directed edge AD is an axis edge.

The major edges all combined form a single longitude of the solid torus. Using this directed longitude, using the directed meridinal curve ACBA and assuming the spiralled solid torus contains n tetrahedra, the minor edges all combined form a (2, n) curve and the axis edges all combined form a (3, n) curve on the torus boundary.

Note that all tetrahedra in the spiralled solid torus must be distinct and there must be at least one tetrahedron.

Note also that class NTriSolidTorus represents a spiralled solid torus with precisely three tetrahedra. A spiralled solid torus with only one tetrahedron is in fact a (1,2,3) layered solid torus.

All optional NStandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

regina::NSpiralSolidTorus::~NSpiralSolidTorus | ( |  | ) |

inline virtual

Destroys this spiralled solid torus.

## Member Function Documentation

NSpiralSolidTorus* regina::NSpiralSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

void regina::NSpiralSolidTorus::cycle | ( | unsigned long | k | ) |

Cycles this spiralled solid torus by the given number of tetrahedra.

Tetrahedra k, k+1, k+2 and so on will become tetrahedra 0, 1, 2 and so on respectively. Note that this operation will not change the vertex roles.

The underlying triangulation is not changed; all that changes is how this spiralled solid torus is represented.

Parameters

  k | the number of tetrahedra through which we should cycle.

static NSpiralSolidTorus* regina::NSpiralSolidTorus::formsSpiralSolidTorus | ( | NTetrahedron * | tet,
|  | NPerm4 | useVertexRoles
| ) |  |

static

Determines if the given tetrahedron forms part of a spiralled solid torus with its vertices playing the given roles in the solid torus.

Note that the boundary triangles of the spiralled solid torus need not be boundary triangles within the overall triangulation, i.e., they may be identified with each other or with triangles of other tetrahedra.

Parameters

  tet | the tetrahedron to examine.
  useVertexRoles | a permutation describing the role each tetrahedron vertex must play in the solid torus; this must be in the same format as the permutation returned by getVertexRoles().

Returns
  a newly created structure containing details of the solid torus with the given tetrahedron as tetrahedron 0, or `null` if the given tetrahedron is not part of a spiralled solid torus with the given vertex roles.

NAbelianGroup* regina::NSpiralSolidTorus::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

NManifold* regina::NSpiralSolidTorus::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

unsigned long regina::NSpiralSolidTorus::getNumberOfTetrahedra | ( |  | ) | const

inline

Returns the number of tetrahedra in this spiralled solid torus.

Returns
  the number of tetrahedra.

NTetrahedron * regina::NSpiralSolidTorus::getTetrahedron | ( | unsigned long | index | ) | const

inline

Returns the requested tetrahedron in this spiralled solid torus.

Tetrahedra are numbered from 0 to getNumberOfTetrahedra()-1 inclusive, with tetrahedron i+1 being placed above tetrahedron i.

Parameters

  index | specifies which tetrahedron to return; this must be between 0 and getNumberOfTetrahedra()-1 inclusive.

Returns
  the requested tetrahedron.

NPerm4 regina::NSpiralSolidTorus::getVertexRoles | ( | unsigned long | index | ) | const

inline

Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus.

The permutation returned (call this `p`) maps 0, 1, 2 and 3 to the four vertices of tetrahedron index so that vertices `p[0]`, `p[1]`, `p[2]` and `p[3]` correspond to vertices A, B, C and D respectively as described in the general class notes.

In particular, the directed edge from vertex `p[0]` to `p[3]` is an axis edge, directed edges `p[0]` to `p[2]` and `p[1]` to `p[3]` are minor edges and the directed path from vertices `p[0]` to `p[1]` to `p[2]` to `p[3]` follows the three major edges.

See the general class notes for further details.

Parameters

  index | specifies which tetrahedron in the solid torus to examine; this must be between 0 and getNumberOfTetrahedra()-1 inclusive.

Returns
  a permutation representing the roles of the vertices of the requested tetrahedron.

bool regina::NSpiralSolidTorus::isCanonical | ( | const NTriangulation * | tri | ) | const

Determines whether this spiralled solid torus is in canonical form.

Canonical form is described in detail in the description for makeCanonical().

Parameters

  tri | the triangulation in which this solid torus lives.

Returns
  `true` if and only if this spiralled solid torus is in canonical form.

bool regina::NSpiralSolidTorus::makeCanonical | ( | const NTriangulation * | tri | ) |

Converts this spiralled solid torus into its canonical representation.

The canonical representation of a spiralled solid torus is unique in a given triangulation.

Tetrahedron 0 in the spiralled solid torus will be the tetrahedron with the lowest index in the triangulation, and under permutation `getVertexRoles(0)` the image of 0 will be less than the image of 3.

Parameters

  tri | the triangulation in which this solid torus lives.

Returns
  `true` if and only if the representation of this spiralled solid torus was actually changed.

void regina::NSpiralSolidTorus::reverse | ( |  | ) |

Reverses this spiralled solid torus.

Tetrahedra 0, 1, 2, ..., getNumberOfTetrahedra()-1 will become tetrahedra getNumberOfTetrahedra()-1, ..., 2, 1, 0 respectively. Note that this operation will change the vertex roles as well.

The underlying triangulation is not changed; all that changes is how this spiralled solid torus is represented.

std::ostream & regina::NSpiralSolidTorus::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NSpiralSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NSpiralSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nspiralsolidtorus.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).